//********************************************************
//* REKURSIVE Implementierung des Euklides Algorithmus zur Berechnung des ggT
//************************************************************

#include <iostream> //Wir brauchen nur E/A Funktionen

using namespace std;

//Deklaration der Funktion ggT
//Rueckgabe: eine ganze Zahl
//bergabeparameter: zwei ganze Zahlen

int ggT (int , int);

int main (void)
{
    //Deklaration der Variablen
    int zahl1, zahl2;
    int zahlGGT;

    cout << "Berechnung des groessten gemeinsamen Teiler durch Rekursion\n\n";
        
    //Aufforderung der Werte dem Benutzer
    cout << "Bitte geben Sie die 1. Zahl ein" << endl;
    cin >> zahl1;
    
    cout << "Bitte geben Sie die 2. Zahl ein" << endl;
    cin >> zahl2;
    
    zahlGGT = ggT (zahl1, zahl2); //Aufruf der Funktion mit den eingegebenen Zahlen
                                  //als Parameter
                                  //Die Rckgabe wird in zahlGGT gespeichert.
                                  
    cout << "\n\nDer groessten gemeinsamen Teiler ist " << zahlGGT;
    
    cout << endl << endl;
    system ("pause");
    
    return 0;
}

    
//Definition der Funktion. Achtung: Rekursivitaet!
int ggT (int x, int y)
{
    int ergebnisGGT;
    int z;
    
    if ( y == 0 ) //falls y gleich 0, der GGT ist x selber
    {
       ergebnisGGT = x;
    }
    else
    {
        z = x % y; //x Modulo y wird berechnet
        //REKUSION!!! Die Funktion ggT wird in der Funktion ggT aufgerufen
        ergebnisGGT = ggT ( y, z ); 
    } 
    
    return ergebnisGGT;
}
